# Quick TODO list

*P* = pending; *W* = working on it; *D* = done.

## Critical for MVP

- *D* LMDB back end
- *D* Hash table back end
- *D* Namespace manager
- *D* N3 serialization / deserialization
- *D* Environment
- *D* Better error handling
- *D* Logging
- *D* Store graph
- *D* Python bindings
    - *D* Basic module framework
    - *D* term, triple, graph modules
    - *D* Codec integration
    - *D* Graph remove and lookup ops
    - *D* Namespace module
    - *D* Tests (basic)
    - *D* Subclass term types
- *D* Namespaced IRIs
- *D* Relative IRIs
- *D* Flexible store interface
- *D* Transaction control
- *W* Turtle serialization / deserialization
  - *D* TTL decoder
  - *W* TTL encoder
- *W* Enhanced graph operations
    - *W* Extract unique terms and 2-term tuples
- *P* Full UTF-8 support
- *P* Extended tests
    - *P* C API
      - *P* Codec (full W3C suite + custom cases)
    - *P* Python API


## Non-critical for MVP

- Graph checksum and semantic equality
- Term and triple validation
- NQ codec
- TriG codec


## Long-term

- Generic graph (non RDF constrained)
- Lua bindings
